/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.geronimo.samples.datacdinfo.web;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

import javax.annotation.Resource;
import javax.ejb.EJB;
import javax.naming.InitialContext;
import javax.naming.NameClassPair;
import javax.naming.NamingEnumeration;
import javax.naming.NamingException;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;
import javax.persistence.Query;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;

//import org.apache.geronimo.samples.datacdinfo.core.MySessionBeanLocal;

/**
 * Servlet implementation class ListOwnerServlet
 * 
 * This servlet demo how to use application-managed persistence context to
 * access database. Note that there must inject an UserTransaction resource to
 * manually manage transaction before using EntityManager to query database.
 */
public class ListOwnerServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;

	@PersistenceUnit(unitName = "DataCDInfoUnit")
	private EntityManagerFactory emf;
	@Resource
	private UserTransaction utx;
	
	//@EJB
	//MySessionBeanLocal mysessionbean;

	/**
	 * @see HttpServlet#HttpServlet()
	 */
	public ListOwnerServlet() {
		super();
		// TODO Auto-generated constructor stub
	}

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse
	 *      response)
	 */
	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		service(request, response);
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse
	 *      response)
	 */
	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		service(request, response);
	}

	protected void service(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {

		List<Object[]> owners = new ArrayList<Object[]>();

		EntityManager em = emf.createEntityManager();
		try {
			utx.begin();
			Query query = em.createNativeQuery("select * from OWNER_TABLE");
			owners = query.getResultList();
			utx.commit();
		} catch (Exception e) {
			e.printStackTrace();
		}

		res.setContentType("text/html");
		PrintWriter out = res.getWriter();

		out.print("<html>");
		out.print("<head><title>Registered Owners</title></head>");
		out.print("<body>");

		for (Object[] owner : owners) {
			out.print(owner[0].toString() + "/" + owner[1].toString() + "<br>");
		}
		
		out.print("</body>");
		out.print("</html>");

		/*try {
			// printNameSpace(out);
			out.print("<br><br>Web container context:<br>");
			InitialContext ctx = new InitialContext();
			String name = "jca:";
			printNameSpace2(out, ctx, name);
			
			out.print("<br><br>EJB container context:<br>");
			mysessionbean.setOut(out);
			mysessionbean.callPrintNameSpace("java:");
		} catch (NamingException e) {
			e.printStackTrace();
		} finally {
			out.print("</body>");
			out.print("</html>");
		}*/

		// out.print(System.getProperties());

	}

  /*
	public void printNameSpace(PrintWriter out) throws NamingException {
		InitialContext ctx = new InitialContext();
		NamingEnumeration<NameClassPair> allnames = ctx.list("jca:/");

		if (allnames.hasMoreElements()) {
			int i = 0;
			while (allnames.hasMore()) {
				NameClassPair ncp = allnames.next();
				out.print(++i + "--" + ncp.getName() + "=" + ncp.getClassName()
						+ "<br>");
				NamingEnumeration<NameClassPair> secondnames = ctx.list("jca:/"
						+ ncp.getName());
				if (secondnames.hasMoreElements()) {
					int j = 0;
					while (secondnames.hasMore()) {
						NameClassPair ncp2 = secondnames.next();
						out.print(i + "." + ++j + "--" + ncp2.getName()
								+ ncp.getClassName() + "<br>");
					}
				}
			}
		} else {
			out.print("Nothing found!<br>");
		}

	}

	public void printNameSpace2(PrintWriter out, InitialContext ctx, String name)
			throws NamingException {
		NamingEnumeration<NameClassPair> allnames = ctx.list(name);

		if (allnames.hasMoreElements()) {
			while (allnames.hasMore()) {
				NameClassPair ncp = allnames.next();
				String subname = ncp.getName();
				String subclassname = ncp.getClassName();
				if (subclassname.endsWith("NestedWritableContext")) {
					printNameSpace2(out, ctx, name + "/" + subname);
				} else {
					out.print(name + "=" + subclassname + "<br>");
				}
			}
		}
	}
	*/

}
