/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.geronimo.samples.datacdinfo.web.struts1;


import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import javax.ejb.EJB;

import org.apache.geronimo.samples.datacdinfo.core.DataCDInfoRemote;

public class DataCDInfoContextListener implements ServletContextListener {
	private ServletContext ctx = null;
	@EJB
	private DataCDInfoRemote logic = null;	

	
	public void contextDestroyed(ServletContextEvent event) {
		ctx = event.getServletContext();		
		ctx.removeAttribute("logic");		
	}

	
	public void contextInitialized(ServletContextEvent event) {
		ctx = event.getServletContext();
		
		if (logic instanceof DataCDInfoRemote) {
			ctx.setAttribute("logic", logic);
			//System.out.println(">>>>>>>>>>>>>>>>>>>>> Injected ejb DataCDInfoJTAImpl!");
		} else {
			System.out.println(">>>>>>>>>>>>>>>>>>>>> Cannot inject ejb DataCDInfoJTAImpl!");
		}
	}

}
